import java.util.Iterator;

import org.apache.log4j.Logger;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;

import com.justep.system.util.*;
import com.justep.system.process.*;
import com.justep.system.context.*;
import com.justep.system.opm.*;
import com.justep.system.data.*;
import com.justep.system.action.*;
import com.justep.model.*;

public class RgcbdrProcess {
	private static Logger logger = Logger.getLogger(RgcbdrProcess.class);
	// 内部单位 人工成本Excel导入前校验
	public static void rgcbdrProcessAfterImportExcelBeforeAction() throws Exception {
		// 导入各单位数据
		System.out.println("导入前");
		Workbook workBook = (Workbook) ModelUtils.getRequestContext().getActionContext().getParameter("excel");
		Sheet sheet = workBook.getSheetAt(0);

		// 根据员工编号获取核算单位编号和名称
		String workcode = ContextHelper.getPersonMember().getCode();// 获取人员工号
		String sql1 = "select t.fHSDWBH,t.fHSDWMC from RG_HSDWGLY t where t.fGLYBH ='" + workcode + "' ";
		Table table1 = KSQL.select(sql1, null, "/RGCBTJ/system/data", null);
		Iterator<com.justep.system.data.Row> it1 = table1.iterator();
		String hsdwbh = "";// 核算单位部门号
		String hsdwmc = "";// 核算单位名称
		while (it1.hasNext()) {
			com.justep.system.data.Row row0 = (com.justep.system.data.Row) it1.next();
			hsdwbh = row0.getString("fHSDWBH");
			hsdwmc = row0.getString("fHSDWMC");
		}

		for (int i = 2; i <= sheet.getLastRowNum(); i++) {
			Row row = sheet.getRow(i);
			String year = (int) row.getCell(0).getNumericCellValue() + "";// 年份
			String month = (int) row.getCell(1).getNumericCellValue() + "";// 月份
			// 人工成本相对应的数据是否存在
			String sql = "SELECT count(0) as cnt FROM Xx_rg_unitdata_tb p WHERE p.DEPTID ='" + hsdwbh + "' and p.TYPE='RGF' and p.YEAR1=" + year + " and p.MONTH1=" + month;
			Table table = KSQL.select(sql, null, "/RGCBTJ/main/data", null);
			Iterator<com.justep.system.data.Row> it = table.iterator();
			if (it.hasNext()) {
				com.justep.system.data.Row datarow = (com.justep.system.data.Row) it.next();
				int cnt = datarow.getInt("cnt");
				if (cnt == 0) {
					String message = "第" + (i + 1) + "行，系统还未同步核算单位:" + hsdwmc + "," + year + "年," + month + "月" + "其他相关数据！";
					System.out.println(message);
					logger.error(message);
					throw new Exception(message);
				} else {

				}
			}
		}
	}

	// 内部单位 人工成本Excel导入后处理
	public static void rgcbdrProcessAfterImportExcelAfterAction() {
		System.out.println("导入后");
		// 获得excel文件
		Workbook workBook = (Workbook) ModelUtils.getRequestContext().getActionContext().getParameter("excel");
		Sheet sheet = workBook.getSheetAt(0);
		// 根据员工编号获取核算单位编号和名称
		String workcode = ContextHelper.getPersonMember().getCode();// 获取人员工号
		String sql1 = "select t.fHSDWBH,t.fHSDWMC from RG_HSDWGLY t where t.fGLYBH ='" + workcode + "' ";
		Table table1 = KSQL.select(sql1, null, "/RGCBTJ/system/data", null);
		Iterator<com.justep.system.data.Row> it1 = table1.iterator();
		String hsdwbh = "";// 核算单位部门号
		String hsdwmc = "";// 核算单位名称
		while (it1.hasNext()) {
			com.justep.system.data.Row row0 = (com.justep.system.data.Row) it1.next();
			hsdwbh = row0.getString("fHSDWBH");
			hsdwmc = row0.getString("fHSDWMC");
		}

		for (int i = 2; i <= sheet.getLastRowNum(); i++) {
			Row row = sheet.getRow(i);
			String year = (int) row.getCell(0).getNumericCellValue() + "";// 年份
			String month = (int) row.getCell(1).getNumericCellValue() + "";// 月份
			
			
			
			if (row.getCell(2) != null) {
				double rgcb_fddxbc = (double) row.getCell(2).getNumericCellValue();// 人工成本-浮动兑现补差
			}
			if (row.getCell(3) != null) {
				double rgcb_lwfbrs = (double) row.getCell(3).getNumericCellValue();// 人工成本-劳务分包人数
			}
			if (row.getCell(4) != null) {
				double rgcb_lwfbfy = (double) row.getCell(4).getNumericCellValue();// 人工成本-劳务分包费用
			}
			if (row.getCell(5) != null) {
				double rgcb_ctfy = (double) row.getCell(5).getNumericCellValue();// 人工成本-辞退费用
			}
			if (row.getCell(6) != null) {
				double rgcb_qtrgcb = (double) row.getCell(6).getNumericCellValue();// 人工成本-其他人工成本
			}

		}
	}
}