import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;

import com.justep.model.ModelUtils;

public class RgcbtjProcess {

	public static void rgcbtjProcessAfterExportExcelAfterAction() {
		HSSFWorkbook workBook =(HSSFWorkbook)ModelUtils.getRequestContext().getActionContext().getParameter("excel");//获取主表的excel
        HSSFSheet sheet=workBook.getSheetAt(0);
        //表头单元格样式
        HSSFCellStyle style = workBook.createCellStyle();
        style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
        style.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);
        HSSFFont font = workBook.createFont();
        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
        style.setFont(font);
        //所有列加宽
        int rowCells=sheet.getRow(0).getPhysicalNumberOfCells();
        for(int i=0;i<rowCells;i++){
        	sheet.setColumnWidth(i, 10 * 512);
        }
        //在最上面增加一行
        sheet.shiftRows(0,sheet.getLastRowNum(),1);
        HSSFRow newRow = sheet.createRow(0);
        
        //处理A列表头
        Cell newCell0 = newRow.createCell(0);
        newCell0.setCellValue("年度");
        newCell0.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region0 = new CellRangeAddress(0, 1, 0, 0);
        sheet.addMergedRegion(region0);
        
        //处理B列表头
        Cell newCell1 = newRow.createCell(1);
        newCell1.setCellValue("核算单位名称");
        newCell1.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region1 = new CellRangeAddress(0, 1, 1, 1);
        sheet.addMergedRegion(region1);
        
        //处理C列表头
        Cell newCell2 = newRow.createCell(2);
        newCell2.setCellValue("核算单位部门号");
        newCell2.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region2 = new CellRangeAddress(0, 1, 2, 2);
        sheet.addMergedRegion(region2);
        
        //处理DEF列表头
        Cell newCell3 = newRow.createCell(3);
        newCell3.setCellValue("经营考核指标");
        newCell3.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region3 = new CellRangeAddress(0, 0, 3, 5);
        sheet.addMergedRegion(region3);
        
        //处理GHIJKL列表头
        Cell newCell4 = newRow.createCell(6);
        newCell4.setCellValue("经营考核截至目前完成情况");
        newCell4.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region4 = new CellRangeAddress(0, 0, 6, 11);
        sheet.addMergedRegion(region4);
        
        //处理MNO列表头
        Cell newCell5 = newRow.createCell(12);
        newCell5.setCellValue("工资总额预核定额");
        newCell5.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region5 = new CellRangeAddress(0, 0, 12, 14);
        sheet.addMergedRegion(region5);
        
        //处理PQR列表头
        Cell newCell6 = newRow.createCell(15);
        newCell6.setCellValue("工资总额实际已发放金额");
        newCell6.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region6 = new CellRangeAddress(0, 0, 15, 17);
        sheet.addMergedRegion(region6);
        
        //处理STU列表头
        Cell newCell7 = newRow.createCell(18);
        newCell7.setCellValue("实际已发放金额与预核定额占比");
        newCell7.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region7 = new CellRangeAddress(0, 0, 18, 20);
        sheet.addMergedRegion(region7);
        
        //处理VWX列表头
        Cell newCell8 = newRow.createCell(21);
        newCell8.setCellValue("工资总额剩余可发放额度");
        newCell8.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region8 = new CellRangeAddress(0, 0, 21, 23);
        sheet.addMergedRegion(region8);
        
        //处理YZAA列表头
        Cell newCell9 = newRow.createCell(24);
        newCell9.setCellValue("待发放工资、奖金统计和预估");
        newCell9.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region9 = new CellRangeAddress(0, 0, 24, 26);
        sheet.addMergedRegion(region9);
        
        //处理AB AC AD列表头
        Cell newCell10 = newRow.createCell(27);
        newCell10.setCellValue("已发放及待发放工资奖金合计预估与预核定额占比");
        newCell10.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region10 = new CellRangeAddress(0, 0, 27, 29);
        sheet.addMergedRegion(region10);
        
        //处理AE AF AG列表头
        Cell newCell11 = newRow.createCell(30);
        newCell11.setCellValue("扣减待发放金额后剩余可用额度");
        newCell11.setCellStyle(style);
        //起始行，结束行，起始列，结束列
        CellRangeAddress region11 = new CellRangeAddress(0, 0, 30, 32);
        sheet.addMergedRegion(region11);
        
        //对占比的项 转换成百分比的格式
        for(int i=2;i<=sheet.getLastRowNum();i++){
        	if(sheet.getRow(i).getCell(7)!=null){
        		double num1=Double.parseDouble(sheet.getRow(i).getCell(7).getStringCellValue());
        		sheet.getRow(i).getCell(7).setCellValue(formatDouble(num1*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(9)!=null){
        		double num2=Double.parseDouble(sheet.getRow(i).getCell(9).getStringCellValue());
        		sheet.getRow(i).getCell(9).setCellValue(formatDouble(num2*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(11)!=null){
        		double num3=Double.parseDouble(sheet.getRow(i).getCell(11).getStringCellValue());
        		sheet.getRow(i).getCell(11).setCellValue(formatDouble(num3*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(18)!=null){
        		double num4=Double.parseDouble(sheet.getRow(i).getCell(18).getStringCellValue());
        		sheet.getRow(i).getCell(18).setCellValue(formatDouble(num4*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(19)!=null){
        		double num5=Double.parseDouble(sheet.getRow(i).getCell(19).getStringCellValue());
        		sheet.getRow(i).getCell(19).setCellValue(formatDouble(num5*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(20)!=null){
        		double num6=Double.parseDouble(sheet.getRow(i).getCell(20).getStringCellValue());
        		sheet.getRow(i).getCell(20).setCellValue(formatDouble(num6*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(27)!=null){
        		double num7=Double.parseDouble(sheet.getRow(i).getCell(27).getStringCellValue());
        		sheet.getRow(i).getCell(27).setCellValue(formatDouble(num7*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(28)!=null){
        		double num8=Double.parseDouble(sheet.getRow(i).getCell(28).getStringCellValue());
        		sheet.getRow(i).getCell(28).setCellValue(formatDouble(num8*100)+"%");
        	}
        	if(sheet.getRow(i).getCell(29)!=null){
        		double num9=Double.parseDouble(sheet.getRow(i).getCell(29).getStringCellValue());
        		sheet.getRow(i).getCell(29).setCellValue(formatDouble(num9*100)+"%");
        	}
        }
	}
	public static String formatDouble(double d) {
		NumberFormat nf = NumberFormat.getNumberInstance();
		// 保留两位小数
		nf.setMaximumFractionDigits(2); 
		// 如果不需要四舍五入，可以使用RoundingMode.DOWN
		nf.setRoundingMode(RoundingMode.UP);
		return nf.format(d);
	}
}